const CALENDAR_SHEET =  SpreadsheetApp.getActiveSpreadsheet().getSheetByName("Calendar");

/**
 * This is the ONLY function that interacts with the rest of the sheet
 * Updates the column H of the calendar with everyone in the directory each day
 * To be run with setup.js
 */
function dailyUpdateCalendar() {
    
}


// event handler to handle typing in column J, between rows 4 and whatever
// if the cell is yellow and there is a handle in there, call the function to retrieve the schedule finder
// check if the handle is a valid handle

// if so, find the handle in the rows below (separate )

// for each column time, if it's green (not red, update the counter in the calendar)

// once done with all column times, highlight amt of people available in green in descending order (think When2Meet)

// when handle is removed, clear the row

function getSchedules() {
    const sheet = CALENDAR_SHEET;
    const startRow = 12;
    const endRow = 127;
    const handleCol = 10; // Column J
    const timeStartCol = 13; // Column M
    const lastCol = sheet.getLastColumn();
  
    const data = sheet.getRange(startRow, 1, endRow - startRow + 1, lastCol).getValues();
    const hourLabels = sheet.getRange(11, timeStartCol, 1, lastCol - timeStartCol + 1).getValues()[0];
  
    data.forEach((row, i) => {
      const handle = row[handleCol - 1];
      if (handle && typeof handle === "string" && handle.trim() !== "") {
        const timeBlocks = row.slice(timeStartCol - 1);
        const summary = [];
  
        timeBlocks.forEach((val, j) => {
          if (val === "Online") {
            const label = Utilities.formatDate(
              hourLabels[j],
              SpreadsheetApp.getActive().getSpreadsheetTimeZone(),
              "h:mm a"
            );
            summary.push(label);
          }
        });
  
        Logger.log(`Handle: ${handle}, Available: ${summary.join(", ")}`);
      }
    });
  }
  
  