// /**
//  * Adds ranks and handles to the "Emails" sheet.
//  * Pulls data from external spreadsheets and updates the "Emails" sheet.
//  */
// function addRanksAndHandles(){
//   let sclLink = "https://docs.google.com/spreadsheets/d/1k19sS9NfwlVfG7GCCf18LO69pr4reSOTN6v1lY2nykQ/edit?gid=693163194#gid=693163194";
//   let emailsRef = SpreadsheetApp.getActiveSpreadsheet().getSheetByName("Emails");
//   let sclRef = SpreadsheetApp.openByUrl(sclLink).getSheetByName("Associates");

//   let handles = sclRef.getRange("A9:A").getValues().flat();
//   let names = sclRef.getRange("B9:B").getValues().flat();
//   let ranks = sclRef.getRange("C9:C").getValues();

//   let endRow = 0
//   for(var i=0; i<handles.length; i++){
//     emailsRef.getRange(i+2, 5).setValue(handles[i]);
//     emailsRef.getRange(i+2, 4).setValue(ranks[i][0].substring(0, 2));
//     endRow = i
//   }
//   let affLink = "https://docs.google.com/spreadsheets/d/1HJmG3VZs0Z-r-aU0hBFg3kjazYimtkJP3tuWky1JRyM/edit?gid=128719830#gid=128719830";
//   let affSheet = SpreadsheetApp.openByUrl(affLink);
//   let affHandles = affSheet.getSheetByName("Affiliates").getRange("A9:A").getValues().flat();
//   let affNames = affSheet.getSheetByName("Affiliates").getRange("B9:B").getValues().flat();
//   let affEmails = affSheet.getSheetByName("Affiliates").getRange("AP9:AP").getValues().flat();
//   endRow-=6;
//   for(var i=endRow; i<affHandles.length+endRow; i++){
//     let handle = affHandles[i-endRow];
//     let name = affNames[i-endRow];
//     if(!handles.includes(handle) && !names.includes(name)){
//       emailsRef.getRange(i, 5).setValue(handle);
//       emailsRef.getRange(i, 1).setValue(name);
//       emailsRef.getRange(i, 2).setValue(affEmails[i-endRow]);
//     }
//   }
// }

// /**
//  * Retrieves the rank associated with a given name from the "Emails" sheet.
//  * 
//  * @param {string} name - The name to search for.
//  * @returns {string|number} The rank if found, 0 if not found, or an error message.
//  */
// function getRank(name){
//   let emailsRef = SpreadsheetApp.getActiveSpreadsheet().getSheetByName("Emails");
//   let names = emailsRef.getRange("E2:E").getValues().flat();
//   if(!names.includes(name)){
//     return 0;
//   }
//   let nameFound = false;
//   let startRow = 2;
//   while(!nameFound){
//     if(emailsRef.getRange(startRow, 5).getValue() === name){
//       return emailsRef.getRange(startRow, 4).getValue();
//     }
//     startRow++;
//   }
//   return "No rank found";
// }

// //Jacob 10/18/24
// /**
//  * Updates data in the "Emails" sheet based on data from Seal Clan Life and AltEmails sheets.
//  */
// function getEmailsAndNames() {

//   // Open the "Seal Clan Life" spreadsheet by its name
//   const sealClanURL = "https://docs.google.com/spreadsheets/d/1k19sS9NfwlVfG7GCCf18LO69pr4reSOTN6v1lY2nykQ/edit?gid=693163194#gid=693163194";
  
//   // Open the spreadsheet by URL
//   const sealClanSheet = SpreadsheetApp.openByUrl(sealClanURL);

//   // getting associates sheet
//   const associatesSheet = sealClanSheet.getSheetByName("Associates");
  
//   // Get the data in columns A/1:handle, D/4:groups, and AP/42:email
//   //note if want names do B/2:names
//   const start=9;

//   //end is when names field is empty, the last row of that length
//   //tries to find the row with something in the names value
//   const namesColumn = associatesSheet.getRange("B:B").getValues();
//   let end = namesColumn.length;

// // Loop backwards to find the last non-empty row in the names column
// for (let i = namesColumn.length - 1; i >= 0; i--) {
//   if (namesColumn[i][0] !== "") { // Check if the cell is not empty
//     end = i; // Row numbers are 1-based, so add 1
//     break;
//   }
// }
// //end-start cause of getRange works
// //    vvvvvvv   should all be type Object[][] 
//   let names = associatesSheet.getRange(start, 2, end-start).getValues();
//   let groups = associatesSheet.getRange(start, 4, end-start).getValues();
//   let emails = associatesSheet.getRange(start, 42, end-start).getValues();

  

  

//   // append data from alt emails list
//   const sheetAltEmails = SpreadsheetApp.getActiveSpreadsheet().getSheetByName("AltEmails");
//   names = names.concat(sheetAltEmails.getRange(2, 1, sheetAltEmails.getLastRow()).getValues());
//   groups = groups.concat(sheetAltEmails.getRange(2, 3, sheetAltEmails.getLastRow()).getValues());
//   emails = emails.concat(sheetAltEmails.getRange(2, 2, sheetAltEmails.getLastRow()).getValues());
//   // open data sheet titled emails
//   let dataSheet=SpreadsheetApp.getActiveSpreadsheet().getSheetByName("Emails")
  
  
  
//   // Set the values of column 1, at row 2 to handles
//   /*const handleRange = dataSheet.getRange(2, 1, handles.length);
//   handleRange.setValues(handles);*/
//   //clears sheet
//   if (!dataSheet) {
//   // If the sheet doesn't exist, create it
//   dataSheet = SpreadsheetApp.getActiveSpreadsheet().insertSheet("Emails");
// } else {
//   // If the sheet already exists, clear its contents 
//   dataSheet.clear();
// }
// // Set up the headers in columns A, B, and C
//   dataSheet.getRange("A1").setValue("name");
//   dataSheet.getRange("B1").setValue("email");
//   dataSheet.getRange("C1").setValue("group");
//   dataSheet.getRange("D1").setValue("ranks");
//   dataSheet.getRange("E1").setValue("handles");

//   // Set the values of column 1, at row 2 to names
//   const namesRange = dataSheet.getRange(2, 1, names.length);
//   namesRange.setValues(names);

//   // Set the values of column 2, at row 2 to emails
//   const emailRange = dataSheet.getRange(2, 2, names.length);
//   emailRange.setValues(emails);
  
//   // Set the values of column 3, at row 2 to group
//   const groupRange = dataSheet.getRange(2, 3, names.length);
//   groupRange.setValues(groups);

//   addRanksAndHandles();
// }

// function getUserNameGroupByEmail() {
//   // Get the email of the user who triggered the function
//   const email = Session.getActiveUser().getEmail(); // This is not working for some reason
//   Logger.log(email);
//   if(email===""){
//     // If email is not uw, will return default values
//   return {
//     name: NAME_PH,
//     group: GROUP_PH
//   };
//   }

//   //if the email is an admin multi sign in account (used for like the computer in SEAL)
//   const sheetAdminEmails = SpreadsheetApp.getActiveSpreadsheet().getSheetByName("AdminSignIns");
//   const emails = sheetAdminEmails.getRange(1, 1, sheetAdminEmails.getLastRow()).getValues();

// // Loop through the emails to see if its an admin account
//   for (let i = 0; i < emails.length; i++) {
//     if (emails[i][0] === email) { // Column B is index 1
//       return {
//         name: NAME_PH, // Column A is index 0
//         group: GROUP_PH // Assuming group is in Column C
//       };
//     }
//   }
  
//   //not an admin email so should do personal email quick login

//   // Open the spreadsheet by name
//   const sheet = SpreadsheetApp.getActiveSpreadsheet().getSheetByName("Emails");
  
//   // Get all the data in the sheet
//   const data = sheet.getDataRange().getValues();
  
//   // Loop through the data to find the email
//   for (let i = 0; i < data.length; i++) {
//     if (data[i][1] === email) { // Column B is index 1
//       return {
//         name: data[i][4], // Column A is index 0
//         group: data[i][2].split(". ")[1] // Assuming group is in Column C
//       };
//     }
//   }
//   //if it reaches this point, email is not in list, so need to write it to the database
//   //should return {name,group}
//   //data of the email spread sheet is passed in the function
//   const newuser=askUserForName(data,email);
//   //data is should be written if name is found in the alt email sheet
//   return newuser;
// }


// function getHandle() {
//   const email = Session.getActiveUser().getEmail();

// }

function updateEmailsSheet() {
  const emailsSheet = SpreadsheetApp.getActiveSpreadsheet().getSheetByName("Emails");
  if (!emailsSheet) return;

  // Clear existing data and set headers
  emailsSheet.clear();
  emailsSheet.getRange("A1:E1").setValues([["name", "email", "group", "rank", "handle"]]);

  let finalData = [];

  // --- SEAL CLAN LIFE ---
  const sclURL = "https://docs.google.com/spreadsheets/d/1k19sS9NfwlVfG7GCCf18LO69pr4reSOTN6v1lY2nykQ/edit";
  const sclSheet = SpreadsheetApp.openByUrl(sclURL).getSheetByName("Associates");

  const sclStart = 9;
  const sclNames = sclSheet.getRange("B9:B").getValues().flat();
  const sclEmails = sclSheet.getRange("AP9:AP").getValues().flat();
  const sclGroups = sclSheet.getRange("D9:D").getValues().flat();
  const sclRanks = sclSheet.getRange("C9:C").getValues().flat();
  const sclHandles = sclSheet.getRange("A9:A").getValues().flat();

  for (let i = 0; i < sclNames.length; i++) {
    if (sclNames[i]) {
      finalData.push([
        sclNames[i],
        sclEmails[i],
        sclGroups[i],
        sclRanks[i],
        sclHandles[i]
      ]);
    }
  }

  // --- AFFILIATES ---
  const affURL = "https://docs.google.com/spreadsheets/d/1HJmG3VZs0Z-r-aU0hBFg3kjazYimtkJP3tuWky1JRyM/edit";
  const affSheet = SpreadsheetApp.openByUrl(affURL).getSheetByName("Affiliates");

  const affNames = affSheet.getRange("B9:B").getValues().flat();
  const affEmails = affSheet.getRange("AP9:AP").getValues().flat();
  const affGroups = affSheet.getRange("D9:D").getValues().flat();
  const affRanks = affSheet.getRange("C9:C").getValues().flat();
  const affHandles = affSheet.getRange("A9:A").getValues().flat();

  for (let i = 0; i < affNames.length; i++) {
    if (affNames[i]) {
      finalData.push([
        affNames[i],
        affEmails[i],
        affGroups[i],
        affRanks[i],
        affHandles[i]
      ]);
    }
  }

  // --- Write everything to Emails sheet ---
  if (finalData.length > 0) {
    emailsSheet.getRange(2, 1, finalData.length, 5).setValues(finalData);
  }
}


function getHandleFromEmail() {
  const email = Session.getActiveUser().getEmail();
  const sheet = SpreadsheetApp.getActiveSpreadsheet().getSheetByName("Emails");
  const data = sheet.getRange(2, 1, sheet.getLastRow() - 1, 5).getValues(); // Columns A-E

  for (let i = 0; i < data.length; i++) {
    if (data[i][1] === email) { // Column B = email
      return data[i][4];        // Column E = handle
    }
  }

  return null; // Not found
}

